SystemOrganization addCategory: #'MC2-Squeak-Smalltalk-Adaptors'!
SystemOrganization addCategory: #'MC2-Squeak-Smalltalk-Elements'!
SystemOrganization addCategory: #'MC2-Squeak-Smalltalk-Fakes'!
SystemOrganization addCategory: #'MC2-Squeak-Smalltalk-Slices'!

MDSlice subclass: #MDChangeSetSlice
	instanceVariableNames: 'changeSet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Smalltalk-Slices'!

!MDChangeSetSlice class methodsFor: 'as yet unclassified' stamp: 'cwp 9/12/2009 11:36'!
elementClass
	^ MDChangeSetSliceElement! !

!MDChangeSetSlice class methodsFor: 'as yet unclassified' stamp: 'jf 10/16/2009 17:06'!
id: aHashstamp
	^ self id: aHashstamp changeSet: nil! !

!MDChangeSetSlice class methodsFor: 'as yet unclassified' stamp: 'jf 10/16/2009 17:19'!
id: aHashstamp changeSet: aChangeSet 
	^ self new
		setId: aHashstamp changeSet: aChangeSet;
		yourself! !

!MDChangeSetSlice class methodsFor: 'as yet unclassified' stamp: 'jf 10/16/2009 17:16'!
on: aChangeSet
	^ self new
		setId: MDHashstamp new changeSet: aChangeSet;
		yourself! !

!MDChangeSetSlice methodsFor: 'private' stamp: 'cwp 2/7/2008 21:52'!
addNameOfPool: anObject to: aSet
	aSet add: (Smalltalk keyAtIdentityValue: anObject ifAbsent: [^ self])! !

!MDChangeSetSlice methodsFor: 'enumerating' stamp: 'cwp 5/22/2008 00:10'!
class: name do: aBlock
	| changes |
	changes := changeSet classChangeAt: name.
	changes isEmpty ifFalse: [aBlock value: (MDClassElement className: name)].
	(changes includes: #comment) ifTrue: [self commentFor: name do: aBlock].
	(changes includes: #change) ifTrue: [self instVarsFor: name do: aBlock].
	self classVarsFor: name do: aBlock.
	self poolImportsFor: name do: aBlock.
	self methodsFor: name do: aBlock.
	
	changes := changeSet classChangeAt: name, ' class'.
	(changes includes: #change) ifTrue: [self classInstVarsFor: name do: aBlock].
	self classMethodsFor: name do: aBlock.! !

!MDChangeSetSlice methodsFor: 'enumerating' stamp: 'cwp 2/6/2008 21:07'!
classInstVarsFor: name do: aBlock	
	(self instVarsFor: name, ' class') do:
		[:ivar | aBlock value: (MDClassInstVarElement className: name name: ivar)]! !

!MDChangeSetSlice methodsFor: 'enumerating' stamp: 'cwp 2/6/2008 20:22'!
classMethodsFor: className do: aBlock
	(changeSet methodChangesAtClass: className, ' class') keys do: 
		[:ea | 
		aBlock value: (MDMethodElement 
						className: className 
						selector: ea 
						classIsMeta: true)]! !

!MDChangeSetSlice methodsFor: 'private' stamp: 'cwp 6/14/2008 12:44'!
classVarsFor: className 
	| classVars class |
	class := self currentClass: className.
	classVars := class ifNil: [Set new] ifNotNil: [class classVarNames].
	classVars addAll: (self oldClassVarsFor: className).
	^ classVars! !

!MDChangeSetSlice methodsFor: 'enumerating' stamp: 'cwp 2/6/2008 22:26'!
classVarsFor: name do: aBlock	
	(self classVarsFor: name) do:
		[:cvar | aBlock value: (MDClassVarElement 
								className: name 
								name: cvar)]! !

!MDChangeSetSlice methodsFor: 'enumerating' stamp: 'cwp 2/5/2008 22:34'!
commentFor: className do: aBlock
	aBlock value: (MDClassCommentElement className: className)! !

!MDChangeSetSlice methodsFor: 'private' stamp: 'cwp 2/5/2008 22:31'!
currentClass: className
	^ Smalltalk classNamed: className! !

!MDChangeSetSlice methodsFor: 'enumerating' stamp: 'cwp 2/6/2008 22:41'!
elementsDo: aBlock
	(changeSet changedClassNames reject: [:ea | ea includes: $ ])
		do: [:ea | self class: ea do: aBlock]! !

!MDChangeSetSlice methodsFor: 'testing' stamp: 'cwp 10/17/2009 20:49'!
includes: anElement 
	^ anElement handleWith: (MDSmalltalkInclusionHandler on: self)! !

!MDChangeSetSlice methodsFor: 'dispatching' stamp: 'cwp 2/5/2008 00:28'!
includesClass: anElement
	^ (changeSet classChangeAt: anElement theClassName) isEmpty not! !

!MDChangeSetSlice methodsFor: 'dispatching' stamp: 'cwp 2/5/2008 00:13'!
includesClassComment: anElement
	^ (changeSet classChangeAt: anElement theClassName) includes: #comment! !

!MDChangeSetSlice methodsFor: 'dispatching' stamp: 'cwp 2/6/2008 21:20'!
includesClassInstVar: anElement 
	^ (self instVarsFor: anElement theClassName, ' class') includes: anElement name! !

!MDChangeSetSlice methodsFor: 'dispatching' stamp: 'cwp 2/6/2008 23:00'!
includesClassVar: anElement 
	^ (self classVarsFor: anElement theClassName) includes: anElement name! !

!MDChangeSetSlice methodsFor: 'dispatching' stamp: 'cwp 2/5/2008 22:17'!
includesInstVar: anElement 
	^ (self instVarsFor: anElement theClassName) includes: anElement name! !

!MDChangeSetSlice methodsFor: 'dispatching' stamp: 'cwp 5/22/2008 00:10'!
includesMethod: anElement
	| name |
	name := anElement classIsMeta
				ifTrue: [anElement theClassName, ' class']
				ifFalse: [anElement theClassName].
	^ (changeSet methodChangesAtClass: name)
		keys includes: anElement selector! !

!MDChangeSetSlice methodsFor: 'dispatching' stamp: 'cwp 2/7/2008 22:16'!
includesPoolImport: anElement 
	^ (self poolImportsFor: anElement theClassName) includes: anElement name! !

!MDChangeSetSlice methodsFor: 'private' stamp: 'cwp 6/14/2008 12:50'!
instVarsFor: className 
	| instVars class |
	instVars := Set new.
	(changeSet structures at: className ifAbsent: [#(first)]) allButFirst 
		collect: [:ea | instVars add: ea].
	class := self currentClass: className.
	class ifNotNil: [class instVarNames do: [:ea | instVars add: ea]].
	^ instVars! !

!MDChangeSetSlice methodsFor: 'enumerating' stamp: 'cwp 2/5/2008 22:24'!
instVarsFor: name do: aBlock	
	(self instVarsFor: name) do:
		[:ivar | aBlock value: (MDInstVarElement className: name name: ivar)]! !

!MDChangeSetSlice methodsFor: 'enumerating' stamp: 'cwp 2/5/2008 23:41'!
methodsFor: className do: aBlock
	(changeSet methodChangesAtClass: className) keys do: 
		[:ea | aBlock value: (MDMethodElement className: className selector: ea)]! !

!MDChangeSetSlice methodsFor: 'accessing' stamp: 'cwp 5/28/2008 21:50'!
name
	^ changeSet name! !

!MDChangeSetSlice methodsFor: 'private' stamp: 'cwp 5/22/2008 00:10'!
oldClassVarsFor: className
	| definition tokens |
	definition := (changeSet changeRecorderFor: className) priorDefinition.
	definition ifNil: [^ #()].
	tokens := Scanner new scanTokens: definition.
	^ ((tokens at: 7) findTokens: $ ) collect: [:ea | ea asSymbol]! !

!MDChangeSetSlice methodsFor: 'private' stamp: 'cwp 6/14/2008 12:58'!
poolImportsFor: className 
	| names class |
	names := Set new.
	class := self currentClass: className.
	class ifNotNil: 
		[class sharedPools do: 
			[:each | 
			self 
				addNameOfPool: each
				to: names]].
	^ names! !

!MDChangeSetSlice methodsFor: 'enumerating' stamp: 'cwp 2/7/2008 22:13'!
poolImportsFor: className do: aBlock
	(self poolImportsFor: className) do:
		[:ea | aBlock value: (MDPoolImportElement className: className name: ea)]! !

!MDChangeSetSlice methodsFor: 'initializing' stamp: 'jf 10/16/2009 17:06'!
setId: aHashstamp changeSet: aChangeSet
	self setId: aHashstamp.
	changeSet := aChangeSet! !

MDSlice subclass: #MDPackageInfoSlice
	instanceVariableNames: 'package'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Smalltalk-Slices'!

!MDPackageInfoSlice class methodsFor: 'converting' stamp: 'cwp 9/12/2009 12:30'!
elementClass
	^ MDPackageInfoSliceElement! !

!MDPackageInfoSlice class methodsFor: 'instance creation' stamp: 'abc 1/1/2007 01:03'!
forDefinition: properties
	^ self named: properties name! !

!MDPackageInfoSlice class methodsFor: 'instance creation' stamp: 'cwp 3/3/2005 00:49'!
forPackage: aPackage
	^ self basicNew setPackage: aPackage! !

!MDPackageInfoSlice class methodsFor: 'instance creation' stamp: 'jf 10/16/2009 22:56'!
id: aHashstamp package: aPackageInfo
	^ self new
		setId: aHashstamp package: aPackageInfo! !

!MDPackageInfoSlice class methodsFor: 'instance creation' stamp: 'cwp 8/28/2005 18:02'!
named: aString
	^ self forPackage: (PackageInfo named: aString)! !

!MDPackageInfoSlice methodsFor: 'private' stamp: 'cwp 5/21/2008 19:09'!
class: aClass do: aBlock 
	aBlock value: (MDClassElement className: aClass name).
	aClass hasComment ifTrue: [ aBlock value: (MDClassCommentElement className: aClass name) ].
	self 
		names: aClass instVarNames
		collect: 
			[ :name | 
			MDInstVarElement 
				className: aClass name
				name: name ]
		into: aBlock.
	self 
		names: aClass classVarNames
		collect: 
			[ :name | 
			MDClassVarElement 
				className: aClass name
				name: name ]
		into: aBlock.
	self 
		names: aClass class instVarNames
		collect: 
			[ :name | 
			MDClassInstVarElement 
				className: aClass name
				name: name ]
		into: aBlock.
	self 
		names: aClass poolImportNames
		collect: 
			[ :name | 
			MDPoolImportElement 
				className: aClass name
				name: name ]
		into: aBlock! !

!MDPackageInfoSlice methodsFor: 'private' stamp: 'cwp 3/3/2006 11:15'!
classForElement: anElement
	^ (Smalltalk classNamed: anElement theClassName)! !

!MDPackageInfoSlice methodsFor: 'enumerating' stamp: 'cwp 1/18/2007 23:59'!
elementsDo: aBlock
	package classes do: [:class | self class: class do: aBlock].
	package methods do: [:ea | aBlock value: ea asElement].! !

!MDPackageInfoSlice methodsFor: 'testing' stamp: 'cwp 10/17/2009 23:31'!
includes: anElement 
	^ (MDSmalltalkInclusionHandler on: self) handle: anElement! !

!MDPackageInfoSlice methodsFor: 'testing' stamp: 'cwp 8/29/2005 01:10'!
includesClass: anElement
	^ package includesClassNamed: anElement theClassName! !

!MDPackageInfoSlice methodsFor: 'testing' stamp: 'cwp 8/29/2005 01:09'!
includesClassComment: anElement
	^ package includesClassNamed: anElement theClassName! !

!MDPackageInfoSlice methodsFor: 'testing' stamp: 'cwp 11/7/2007 00:33'!
includesClassInstVar: anElement
	^ (package includesClassNamed: anElement theClassName) and: 
		[(self classForElement: anElement) class instVarNames includes: anElement name]! !

!MDPackageInfoSlice methodsFor: 'testing' stamp: 'cwp 11/7/2007 00:36'!
includesClassVar: anElement
	^ (package includesClassNamed: anElement theClassName)
		and: [(self classForElement: anElement) classVarNames includes: anElement name]! !

!MDPackageInfoSlice methodsFor: 'testing' stamp: 'cwp 11/7/2007 00:35'!
includesInstVar: anElement
	^ (package includesClassNamed: anElement theClassName)
		and: [(self classForElement: anElement) instVarNames includes: anElement name]! !

!MDPackageInfoSlice methodsFor: 'testing' stamp: 'cwp 5/22/2008 00:13'!
includesMethod: anElement
	| ref |
	ref := MethodReference new.
	ref 
		setClassSymbol: anElement theClassName
		classIsMeta: anElement classIsMeta
		methodSymbol: anElement selector
		stringVersion: ''.
	^ package includesMethodReference: ref! !

!MDPackageInfoSlice methodsFor: 'testing' stamp: 'cwp 5/22/2008 00:13'!
includesPoolImport: anElement
	| pool |
	^ (package includesClassNamed: anElement theClassName) and: 
		[pool := Smalltalk at: anElement name ifAbsent: [0].
		(self classForElement: anElement) sharedPools anySatisfy: 
				[:ea | ea == pool]]! !

!MDPackageInfoSlice methodsFor: 'accessing' stamp: 'cwp 3/15/2005 22:26'!
name
	^ package packageName! !

!MDPackageInfoSlice methodsFor: 'private' stamp: 'cwp 3/3/2005 01:48'!
names: aCollection collect: mapBlock into: doBlock
	| elements |
	elements := aCollection collect: mapBlock.
	elements do: doBlock. 
		! !

!MDPackageInfoSlice methodsFor: 'initialize-release' stamp: 'jf 10/16/2009 22:54'!
setId: aHashstamp package: aPackage
	self setId: aHashstamp.
	package := aPackage! !

!MDPackageInfoSlice methodsFor: 'initialize-release' stamp: 'cwp 5/22/2008 00:13'!
setPackage: aPackage
	package := aPackage.
	self initId.! !

!MDSlice methodsFor: '*mc2-squeak-smalltalk-dispatch' stamp: 'cwp 6/7/2008 15:51'!
includesClass: anElement
	^ false! !

!MDSlice methodsFor: '*mc2-squeak-smalltalk-dispatch' stamp: 'cwp 6/7/2008 15:51'!
includesClassComment: anElement
	^ false! !

!MDSlice methodsFor: '*mc2-squeak-smalltalk-dispatch' stamp: 'cwp 6/7/2008 15:51'!
includesClassInstVar: anElement
	^ false! !

!MDSlice methodsFor: '*mc2-squeak-smalltalk-dispatch' stamp: 'cwp 6/7/2008 15:52'!
includesClassVar: anElement
	^ false! !

!MDSlice methodsFor: '*mc2-squeak-smalltalk-dispatch' stamp: 'cwp 6/7/2008 15:52'!
includesInstVar: anElement
	^ false! !

!MDSlice methodsFor: '*mc2-squeak-smalltalk-dispatch' stamp: 'cwp 6/7/2008 15:52'!
includesMethod: anElement
	^ false! !

!MDSlice methodsFor: '*mc2-squeak-smalltalk-dispatch' stamp: 'cwp 6/7/2008 15:52'!
includesPoolImport: anElement
	^ false! !

!Collection methodsFor: '*mc2-squeak-smalltalk' stamp: 'cwp 8/26/2005 21:58'!
disjoin: aCollection
	^ (self union: aCollection) difference: (self intersection: aCollection)! !

MDDomain subclass: #MDSqueakDomain
	instanceVariableNames: 'editor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Smalltalk-Adaptors'!

MDSqueakDomain class
	instanceVariableNames: 'default'!

MDSqueakDomain class
	instanceVariableNames: 'default'!

!MDSqueakDomain class methodsFor: 'accessing' stamp: 'cwp 6/15/2008 20:35'!
default
	^ default ifNil: [default := self new]! !

!MDSqueakDomain class methodsFor: 'instance creation' stamp: 'cwp 11/20/2008 18:53'!
new
	^ self basicNew initialize! !

!MDSqueakDomain class methodsFor: 'accessing' stamp: 'cwp 6/15/2008 20:32'!
type
	^ #smalltalk! !

!MDSqueakDomain methodsFor: 'adaptors' stamp: 'cwp 10/16/2009 22:37'!
adapt: anElement
	^ anElement handleWith: (MDSqueakAdaptionHandler system: editor)! !

!MDSqueakDomain methodsFor: 'initialize-release' stamp: 'cwp 5/7/2008 07:53'!
initialize
	editor := Smalltalk! !

!MDSqueakDomain methodsFor: 'public' stamp: 'cwp 5/26/2008 22:04'!
name
	^ #smalltalk! !

!MDSqueakDomain methodsFor: 'public' stamp: 'cwp 5/22/2008 00:13'!
transaction: aBlock
	|  result tmp |
	tmp := editor.
	[editor := MDPlatform current systemEditor.
	result := aBlock value.
	editor commit]
		ensure: [editor := tmp].

	^ result! !

!Class methodsFor: '*mc2-squeak-smalltalk' stamp: 'cwp 5/20/2008 20:05'!
instanceVariableNames: nameString 
	ClassBuilder new 
		name: self name
		inEnvironment: self environment
		subclassOf: self superclass
		type: self typeOfClass
		instanceVariableNames: nameString
		classVariableNames: self classVariablesString
		poolDictionaries: self sharedPoolsString
		category: self category! !

!Class methodsFor: '*mc2-squeak-smalltalk' stamp: 'cwp 5/21/2008 19:07'!
poolImportNames
	^ self sharedPools collect: [:ea | self environment keyAtIdentityValue: ea]! !

SharedPool subclass: #MDBogusPoolA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Smalltalk-Fakes'!

SharedPool subclass: #MDBogusPoolB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Smalltalk-Fakes'!

MDElementHandler subclass: #MDSqueakAdaptionHandler
	instanceVariableNames: 'editor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Smalltalk-Adaptors'!

!MDSqueakAdaptionHandler class methodsFor: 'instance creation' stamp: 'cwp 10/16/2009 21:53'!
system: aSystemEditor
	^ self basicNew initializeWithSystem: aSystemEditor! !

!MDSqueakAdaptionHandler methodsFor: 'smalltalk' stamp: 'cwp 10/16/2009 21:59'!
handleClass: anElement
	^ MDSqueakClassAdaptor forElement: anElement inSystem: editor! !

!MDSqueakAdaptionHandler methodsFor: 'smalltalk' stamp: 'cwp 10/17/2009 23:35'!
handleClassComment: anElement
	^ MDSqueakClassCommentAdaptor forElement: anElement inSystem: editor! !

!MDSqueakAdaptionHandler methodsFor: 'smalltalk' stamp: 'cwp 10/16/2009 21:59'!
handleClassInstVar: anElement
	^ MDSqueakClassInstVarAdaptor forElement: anElement inSystem: editor! !

!MDSqueakAdaptionHandler methodsFor: 'smalltalk' stamp: 'cwp 10/16/2009 21:59'!
handleClassVar: anElement
	^ MDSqueakClassVarAdaptor forElement: anElement inSystem: editor! !

!MDSqueakAdaptionHandler methodsFor: 'handling' stamp: 'cwp 10/16/2009 22:17'!
handleElement: anElement 
	self error: 'Unrecognized element class: ' , anElement class name! !

!MDSqueakAdaptionHandler methodsFor: 'smalltalk' stamp: 'cwp 10/16/2009 22:00'!
handleInstVar: anElement
	^ MDSqueakInstVarAdaptor forElement: anElement inSystem: editor! !

!MDSqueakAdaptionHandler methodsFor: 'smalltalk' stamp: 'cwp 10/16/2009 22:00'!
handleMethod: anElement
	^ MDSqueakMethodAdaptor forElement: anElement inSystem: editor! !

!MDSqueakAdaptionHandler methodsFor: 'smalltalk' stamp: 'cwp 10/16/2009 22:01'!
handlePoolImport: anElement
	^ MDSqueakPoolImportAdaptor forElement: anElement inSystem: editor! !

!MDSqueakAdaptionHandler methodsFor: 'initialize-release' stamp: 'cwp 10/16/2009 21:55'!
initializeWithSystem: aSystemEditor
	self initialize.
	editor := aSystemEditor! !

MDSliceAdaptor subclass: #MDChangeSetSliceAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Smalltalk-Adaptors'!

!MDChangeSetSliceAdaptor methodsFor: 'private' stamp: 'jf 10/16/2009 22:51'!
createSlice: properties 
	^ MDChangeSetSlice
		id: element id
		changeSet: ((ChangeSet named: properties name) ifNil: [ ChangeSet basicNewChangeSet: properties name ])! !

MDSliceAdaptor subclass: #MDPackageInfoSliceAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Smalltalk-Adaptors'!

!MDPackageInfoSliceAdaptor methodsFor: 'private' stamp: 'jf 10/16/2009 22:56'!
createSlice: properties
	^ MDPackageInfoSlice
		id: element id
		package: (PackageInfo named: properties name)! !

Object subclass: #MDBogusA
	instanceVariableNames: 'one'
	classVariableNames: 'MDAlpha'
	poolDictionaries: 'MDBogusPoolA TextConstants'
	category: 'MC2-Squeak-Smalltalk-Fakes'!

MDBogusA class
	instanceVariableNames: 'aleph'!

MDBogusA class
	instanceVariableNames: 'aleph'!

Object subclass: #MDFakeClassDescription
	instanceVariableNames: 'superclass methodDict format instanceVariables organization name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Smalltalk-Fakes'!

MDFakeClassDescription subclass: #MDFakeClass
	instanceVariableNames: 'subclasses classPool sharedPools environement category'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Smalltalk-Fakes'!

!MDFakeClass class methodsFor: 'instance creation' stamp: 'cwp 8/27/2005 11:50'!
basedOn: aClass
	^ self new initializeFromClass: aClass theNonMetaClass! !

!MDFakeClass methodsFor: 'mutation' stamp: 'cwp 8/27/2005 10:37'!
addClassVarName: aString
	classPool at: aString asSymbol put: nil! !

!MDFakeClass methodsFor: 'mutation' stamp: 'cwp 5/22/2008 00:13'!
addSharedPool: aSharedPool 
	(self sharedPools includes: aSharedPool)
		ifTrue: [^self error: 'This is already in my shared pool list'].
	sharedPools == nil
		ifTrue: [sharedPools := OrderedCollection with: aSharedPool]
		ifFalse: [sharedPools add: aSharedPool]! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/26/2005 18:35'!
category
	^category! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/26/2005 18:35'!
category: anObject
	category := anObject! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/26/2005 18:35'!
classPool
	^classPool! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/26/2005 18:35'!
classPool: anObject
	classPool := anObject! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/27/2005 10:48'!
classVarNames
	^ classPool keys! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/26/2005 18:35'!
environement
	^environement! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/26/2005 18:35'!
environement: anObject
	environement := anObject! !

!MDFakeClass methodsFor: 'initialize-release' stamp: 'cwp 5/22/2008 00:13'!
initializeFromClass: aClass
	superclass := aClass superclass.
	methodDict := aClass methodDict copy.
	format := aClass format.
	name := aClass name.
	organization := aClass organization copy.
	instanceVariables := aClass instVarNames.
	classPool := aClass classPool copy.
	sharedPools := aClass sharedPools copy.
	! !

!MDFakeClass methodsFor: 'testing' stamp: 'cwp 8/27/2005 12:50'!
isMeta
	^ false! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/26/2005 18:35'!
sharedPools
	^sharedPools! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/26/2005 18:35'!
sharedPools: anObject
	sharedPools := anObject! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/26/2005 18:35'!
subclasses
	^subclasses! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/26/2005 18:35'!
subclasses: anObject
	subclasses := anObject! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:55'!
theMetaClass
	^MDFakeMetaclass basedOn: self theRealClass class! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:52'!
theNonMetaClass
	^ self! !

!MDFakeClassDescription methodsFor: 'mutation' stamp: 'cwp 5/22/2008 00:13'!
addInstVarName: aString
	instanceVariables := instanceVariables copyWith: aString! !

!MDFakeClassDescription methodsFor: 'copying' stamp: 'cwp 8/27/2005 11:36'!
copy
	^ self class basedOn: self! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:37'!
format
	^format! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:37'!
format: anObject
	format := anObject! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:37'!
instVarNames
	^ instanceVariables! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 5/22/2008 00:13'!
instVarNames: anArray
	instanceVariables := anArray! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:37'!
methodDict
	^methodDict! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:37'!
methodDict: anObject
	methodDict := anObject! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:38'!
name
	^ name! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 5/22/2008 00:13'!
name: aSymbol
	name := aSymbol! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:39'!
organization
	^organization! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:39'!
organization: anObject
	organization := anObject! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:39'!
superclass
	^superclass! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:39'!
superclass: anObject
	superclass := anObject! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:55'!
theRealClass
	^Smalltalk classNamed: name! !

MDFakeClassDescription subclass: #MDFakeMetaclass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Smalltalk-Fakes'!

!MDFakeMetaclass class methodsFor: 'as yet unclassified' stamp: 'cwp 8/27/2005 11:56'!
basedOn: aMetaclass
	^ self new initializeFromMetaclass: aMetaclass theMetaClass! !

!MDFakeMetaclass methodsFor: 'initialize-release' stamp: 'cwp 5/22/2008 00:13'!
initializeFromMetaclass: aMetaclass
	superclass := aMetaclass superclass.
	methodDict := aMetaclass methodDict copy.
	format := aMetaclass format.
	name := aMetaclass theNonMetaClass name.
	organization := aMetaclass organization copy.
	instanceVariables := aMetaclass instVarNames.
! !

!MDFakeMetaclass methodsFor: 'testing' stamp: 'cwp 8/27/2005 12:50'!
isMeta
	^ true! !

!MDFakeMetaclass methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:53'!
name
	^ name, ' class'! !

!MDFakeMetaclass methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:52'!
theMetaClass
	^ self! !

!MDFakeMetaclass methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:55'!
theNonMetaClass
	^ MDFakeClass basedOn: self theRealClass! !

Object subclass: #MDSqueakElementAdaptor
	instanceVariableNames: 'element system'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Smalltalk-Adaptors'!

MDSqueakElementAdaptor subclass: #MDSqueakClassAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Smalltalk-Adaptors'!

!MDSqueakClassAdaptor methodsFor: 'accessing' stamp: 'cwp 2/6/2005 12:39'!
category
	^ self elementClass category! !

!MDSqueakClassAdaptor methodsFor: 'private' stamp: 'cwp 2/5/2005 22:30'!
classVariablesString
	^ self send: #classVariablesString toClassIfNil: ['']! !

!MDSqueakClassAdaptor methodsFor: 'private' stamp: 'cwp 12/2/2005 22:47'!
elementClass
	^ system at: element theClassName ifAbsent: [nil]! !

!MDSqueakClassAdaptor methodsFor: 'accessing' stamp: 'cwp 2/6/2005 12:39'!
format
	^ self elementClass typeOfClass! !

!MDSqueakClassAdaptor methodsFor: 'private' stamp: 'cwp 2/5/2005 22:30'!
instanceVariablesString
	^ self send: #instanceVariablesString toClassIfNil: ['']! !

!MDSqueakClassAdaptor methodsFor: 'public' stamp: 'cwp 2/15/2005 15:31'!
isLoadable: properties 
	self superclassFrom: properties ifAbsent: [^ false].
	^ true! !

!MDSqueakClassAdaptor methodsFor: 'public' stamp: 'cwp 12/1/2005 22:31'!
isPresent
	^ (system at: element theClassName ifAbsent: [^ false])
		isBehavior! !

!MDSqueakClassAdaptor methodsFor: 'public' stamp: 'cwp 5/22/2008 00:13'!
load: properties
	| superClass |
	superClass := Smalltalk at: properties superclassName.
	ClassBuilder new
		name: element theClassName 
		inEnvironment: superClass environment 
		subclassOf: superClass
		type: properties format 
		instanceVariableNames: self instanceVariablesString 
		classVariableNames: self classVariablesString 
		poolDictionaries: self sharedPoolsString
		category: properties category
! !

!MDSqueakClassAdaptor methodsFor: 'accessing' stamp: 'cwp 2/5/2005 23:02'!
propertyNames
	^ #(category format superclassName)! !

!MDSqueakClassAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 12:39'!
remove
	self elementClass ifNotNilDo: [:class | class removeFromSystem]! !

!MDSqueakClassAdaptor methodsFor: 'private' stamp: 'cwp 2/6/2005 12:39'!
send: aSelector toClassIfNil: aBlock
	| class |
	class := self elementClass.
	^ class 
		ifNotNil: [class perform: aSelector]
		ifNil: aBlock! !

!MDSqueakClassAdaptor methodsFor: 'private' stamp: 'cwp 2/5/2005 22:31'!
sharedPoolsString
	^ self send: #sharedPoolsString toClassIfNil: ['']! !

!MDSqueakClassAdaptor methodsFor: 'private' stamp: 'cwp 5/22/2008 00:13'!
superclassFrom: properties ifAbsent: absentBlock 
	| global |
	global := system 
				at: properties superclassName 
				ifAbsent: [^ absentBlock value].
	^ (global isBehavior)
		ifTrue: [global]
		ifFalse: absentBlock! !

!MDSqueakClassAdaptor methodsFor: 'accessing' stamp: 'cwp 2/6/2005 12:40'!
superclassName
	^ self elementClass superclass name! !

MDSqueakElementAdaptor subclass: #MDSqueakClassCommentAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Smalltalk-Adaptors'!

!MDSqueakClassCommentAdaptor methodsFor: 'public' stamp: 'cwp 6/14/2008 13:56'!
isPresent
	| class |
	class := self elementClass.
	^ class notNil and: [class hasComment]! !

!MDSqueakClassCommentAdaptor methodsFor: 'public' stamp: 'cwp 2/12/2005 14:55'!
load: properties
	self elementClass
		classComment: properties text
		stamp: (self stampFromProperties: properties)! !

!MDSqueakClassCommentAdaptor methodsFor: 'properties' stamp: 'cwp 11/17/2007 01:22'!
propertyNames
	^ #(text initials timeStamp)! !

!MDSqueakClassCommentAdaptor methodsFor: 'public' stamp: 'cwp 2/12/2005 14:59'!
remove
	self elementClass organization classComment: nil stamp: nil.
! !

!MDSqueakClassCommentAdaptor methodsFor: 'properties' stamp: 'cwp 2/12/2005 14:34'!
stamp
	^ self elementClass organization commentStamp! !

!MDSqueakClassCommentAdaptor methodsFor: 'properties' stamp: 'cwp 3/11/2005 21:02'!
text
	^ self elementClass comment asString! !

MDSqueakElementAdaptor subclass: #MDSqueakClassVarAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Smalltalk-Adaptors'!

!MDSqueakClassVarAdaptor methodsFor: 'public' stamp: 'cwp 6/14/2008 13:57'!
isPresent
	| class |
	class := self elementClass.
	^ class notNil and: [class classVarNames includes: element name]! !

!MDSqueakClassVarAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 14:00'!
load: properties
	self isPresent ifFalse: [self elementClass addClassVarName: element name]! !

!MDSqueakClassVarAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 13:59'!
remove
	self isPresent ifTrue: [self elementClass removeClassVarName: element name]! !

!MDSqueakElementAdaptor class methodsFor: 'instance creation' stamp: 'cwp 12/11/2005 10:57'!
forElement: anElement
	^ self forElement: anElement inSystem: Smalltalk! !

!MDSqueakElementAdaptor class methodsFor: 'instance creation' stamp: 'cwp 12/1/2005 21:58'!
forElement: anElement inSystem: aSystemEditor
	^ self new setElement: anElement system: aSystemEditor! !

!MDSqueakElementAdaptor methodsFor: 'public' stamp: 'cwp 3/2/2006 18:08'!
display: properties
	^ properties asString! !

!MDSqueakElementAdaptor methodsFor: 'accessing' stamp: 'cwp 2/6/2005 12:44'!
elementClass
	^ self elementClassIfAbsent: [nil]! !

!MDSqueakElementAdaptor methodsFor: 'accessing' stamp: 'cwp 12/11/2005 11:01'!
elementClassIfAbsent: aBlock
	^ system at: element theClassName ifAbsent: aBlock! !

!MDSqueakElementAdaptor methodsFor: 'accessing' stamp: 'cwp 5/22/2008 00:13'!
initials
	| initials |
	initials := self stamp copyUpTo: $ .
	^ initials isEmpty ifFalse: [initials] ifTrue: [nil]! !

!MDSqueakElementAdaptor methodsFor: 'private' stamp: 'cwp 2/5/2005 21:40'!
is: name upToDateIn: properties
	^ (properties at: name ifAbsent: [^ true]) = (self perform: name)
	! !

!MDSqueakElementAdaptor methodsFor: 'public' stamp: 'cwp 2/15/2005 15:47'!
isLoadable: properties
	self elementClassIfAbsent: [^ false].
	^ true! !

!MDSqueakElementAdaptor methodsFor: 'public' stamp: 'cwp 2/5/2005 21:40'!
isUpToDate: properties 
	self propertyNames
		do: [:property | (self is: property upToDateIn: properties) ifFalse: [^ false]].
	^ true
! !

!MDSqueakElementAdaptor methodsFor: 'public' stamp: 'cwp 2/12/2005 14:08'!
load: properties
	self subclassResponsibility! !

!MDSqueakElementAdaptor methodsFor: 'public' stamp: 'avi 3/16/2005 12:21'!
merge: aPropertyDictionary into: otherPropertyDictionary onFailure: aBlock
	^ aBlock value! !

!MDSqueakElementAdaptor methodsFor: 'properties' stamp: 'cwp 2/6/2005 23:39'!
propertyNames
	^ #()! !

!MDSqueakElementAdaptor methodsFor: 'public' stamp: 'cwp 2/12/2005 14:08'!
remove
	self subclassResponsibility! !

!MDSqueakElementAdaptor methodsFor: 'initialize-release' stamp: 'cwp 5/22/2008 00:13'!
setElement: anElement system: aSystemEditor
	element := anElement.
	system := aSystemEditor! !

!MDSqueakElementAdaptor methodsFor: 'private' stamp: 'cwp 5/22/2008 00:13'!
stampFromProperties: properties
	| initials timestamp |
	initials := properties at: #initials ifAbsent: ['<nobody>'].
	timestamp := properties at: #timeStamp ifAbsent: [^ '<no timestamp>'].
	^ timestamp printFormat: initials, ' %l/%e/%Y %H:%M'
	! !

!MDSqueakElementAdaptor methodsFor: 'accessing' stamp: 'cwp 8/4/2008 22:36'!
timeStamp
	| stamp |
	stamp := self stamp.
	^ (#('' '<historical>' '<no timestamp>') includes: stamp withBlanksTrimmed)
		ifFalse: [MDTimestamp fromSqueakMethodStamp: stamp]
		ifTrue: [nil]
! !

!MDSqueakElementAdaptor methodsFor: 'public' stamp: 'cwp 2/1/2006 21:02'!
update: properties
	self propertyNames do: 
		[:name | (self perform: name) ifNotNilDo: 
			[:value | properties at: name put: value]]! !

MDSqueakElementAdaptor subclass: #MDSqueakInstVarAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Smalltalk-Adaptors'!

MDSqueakInstVarAdaptor subclass: #MDSqueakClassInstVarAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Smalltalk-Adaptors'!

!MDSqueakClassInstVarAdaptor methodsFor: 'accessing' stamp: 'cwp 3/4/2005 15:04'!
elementClassIfAbsent: aBlock
	^ (super elementClassIfAbsent: aBlock) class! !

!MDSqueakInstVarAdaptor methodsFor: 'private' stamp: 'cwp 5/20/2008 07:51'!
assignNamesToEmptySlots: names 
	1 
		to: names size
		do: 
			[ :i | 
			(names at: i) ifNil: 
				[ names 
					at: i
					put: 'instVarAtSlot' , i asString ] ]! !

!MDSqueakInstVarAdaptor methodsFor: 'private' stamp: 'cwp 5/20/2008 07:10'!
basicLoad: properties 
	| names instVarNames index |
	names := self elementClass instVarNames.
	index := properties index.
	instVarNames := self installAt: index in: names.
	self installInstVarNames: instVarNames! !

!MDSqueakInstVarAdaptor methodsFor: 'properties' stamp: 'cwp 5/19/2008 13:26'!
index
	^ (self elementClassIfAbsent: [^ 0])
		instVarNames indexOf: element name! !

!MDSqueakInstVarAdaptor methodsFor: 'private' stamp: 'cwp 5/20/2008 07:58'!
installAt: index in: aCollection 
	| names |
	names := self resize: aCollection for: index.
	self moveInterloperAt: index in: names.
	names at: index put: element name.
	self assignNamesToEmptySlots: names.
	^ names! !

!MDSqueakInstVarAdaptor methodsFor: 'private' stamp: 'cwp 5/20/2008 20:05'!
installInstVarNames: names 
	| nameString |
	nameString := String streamContents: 
		[ :s | 
		names 
			do: [ :ea | s nextPutAll: ea ]
			separatedBy: [ s space ] ].
	self elementClass instanceVariableNames: nameString! !

!MDSqueakInstVarAdaptor methodsFor: 'public' stamp: 'cwp 8/20/2005 18:21'!
isPresent
	^ (self elementClassIfAbsent: [^ false])
		instVarNames includes: element name! !

!MDSqueakInstVarAdaptor methodsFor: 'public' stamp: 'cwp 5/19/2008 19:34'!
load: properties 
	self isPresent ifFalse: [ self basicLoad: properties ]! !

!MDSqueakInstVarAdaptor methodsFor: 'private' stamp: 'cwp 5/20/2008 07:58'!
moveInterloperAt: index in: aCollection
	| current |
	current := aCollection indexOf: element name.
	current = 0 ifTrue: [current := aCollection size].
	aCollection at: current put: (aCollection at: index).! !

!MDSqueakInstVarAdaptor methodsFor: 'properties' stamp: 'cwp 5/19/2008 13:25'!
propertyNames
	^ #(index)! !

!MDSqueakInstVarAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 23:56'!
remove
	self isPresent ifTrue: [self elementClass removeInstVarName: element name]! !

!MDSqueakInstVarAdaptor methodsFor: 'private' stamp: 'cwp 5/20/2008 07:50'!
resize: aCollection for: index 
	| names size |
	size := (aCollection includes: element name) 
		ifTrue: [ aCollection size ]
		ifFalse: [ aCollection size + 1 ].
	names := Array new: (size max: index).
	aCollection doWithIndex: 
		[ :name :i | 
		names 
			at: i
			put: name ].
	^ names! !

MDSqueakElementAdaptor subclass: #MDSqueakMethodAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Smalltalk-Adaptors'!

!MDSqueakMethodAdaptor methodsFor: 'accessing' stamp: 'cwp 2/3/2005 23:06'!
category
	^ self elementClass organization categoryOfElement: element selector! !

!MDSqueakMethodAdaptor methodsFor: 'private' stamp: 'cwp 2/6/2005 12:44'!
compiledMethod 
	^ self elementClass compiledMethodAt: element selector! !

!MDSqueakMethodAdaptor methodsFor: 'public' stamp: 'avi 3/22/2006 19:49'!
display: properties
	^ properties source! !

!MDSqueakMethodAdaptor methodsFor: 'accessing' stamp: 'cwp 2/12/2005 15:24'!
elementClassIfAbsent: aBlock
	| nonMetaClass |
	nonMetaClass := super elementClassIfAbsent: aBlock.
	^ element classIsMeta
		ifTrue: [nonMetaClass class]
		ifFalse: [nonMetaClass]! !

!MDSqueakMethodAdaptor methodsFor: 'public' stamp: 'cwp 6/14/2008 13:56'!
isPresent
	| class |
	class := self elementClass.
	^ class notNil and: [class includesSelector: element selector]! !

!MDSqueakMethodAdaptor methodsFor: 'public' stamp: 'avi 3/14/2005 18:36'!
isUpToDate: aPropertyDictionary
	aPropertyDictionary localReference ifNotNilDo:
		[:compiledMethod |
		compiledMethod = self compiledMethod ifTrue: [^ true]].
	^ super isUpToDate: aPropertyDictionary! !

!MDSqueakMethodAdaptor methodsFor: 'public' stamp: 'cwp 5/22/2008 00:13'!
load: properties
	| selector |
	selector := self elementClass
					compile: (properties at: #source ifAbsent: [self source])
					classified: (properties at: #category ifAbsent: [self category])
					withStamp: (self stampFromProperties: properties)
					notifying: nil
					logSource: true.
! !

!MDSqueakMethodAdaptor methodsFor: 'accessing' stamp: 'cwp 11/17/2007 01:24'!
propertyNames
	^ #(initials timeStamp category source)! !

!MDSqueakMethodAdaptor methodsFor: 'public' stamp: 'cwp 8/14/2005 19:57'!
remove
	(self elementClassIfAbsent: [^ self])
		removeSelector: element selector! !

!MDSqueakMethodAdaptor methodsFor: 'accessing' stamp: 'cwp 3/11/2005 20:44'!
source
	^ (self elementClass sourceCodeAt: (element selector)) asString.! !

!MDSqueakMethodAdaptor methodsFor: 'accessing' stamp: 'cwp 2/12/2005 14:30'!
stamp
	^self compiledMethod timeStamp! !

!MDSqueakMethodAdaptor methodsFor: 'public' stamp: 'avi 3/14/2005 18:32'!
update: aPropertyDictionary
	super update: aPropertyDictionary.
	aPropertyDictionary localReference: self compiledMethod! !

MDSqueakElementAdaptor subclass: #MDSqueakPoolImportAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Smalltalk-Adaptors'!

!MDSqueakPoolImportAdaptor methodsFor: 'private' stamp: 'cwp 5/18/2008 21:44'!
importedPool
	^ system at: element name ifAbsent: [nil]! !

!MDSqueakPoolImportAdaptor methodsFor: 'public' stamp: 'cwp 5/18/2008 21:59'!
isLoadable: properties
	^ (super isLoadable: properties) and: [self importedPool notNil]! !

!MDSqueakPoolImportAdaptor methodsFor: 'public' stamp: 'cwp 10/13/2008 12:49'!
isPresent
	| class |
	class := self elementClass.
	^ class notNil and: 
		[class sharedPools anySatisfy: 
			[:ea | (system keyAtValue: ea ifAbsent: [nil]) = element name ]]! !

!MDSqueakPoolImportAdaptor methodsFor: 'public' stamp: 'cwp 5/22/2008 00:13'!
load: properties
	| class pool |
	class := self elementClass.
	pool := self importedPool.
	(class sharedPools includes: pool)
		ifFalse: [class addSharedPool: pool]! !

!MDSqueakPoolImportAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 23:44'!
remove
	"Work around a bug in Class>>removeSharedPool:"
	
	self elementClass sharedPools remove: self importedPool ifAbsent: []! !

!Object methodsFor: '*mc2-squeak-smalltalk-ui' stamp: 'cwp 4/25/2005 04:04'!
displayOn: aStream
	self printOn: aStream! !

!Object methodsFor: '*mc2-squeak-smalltalk-ui' stamp: 'cwp 4/25/2005 04:03'!
displayString
	^ String streamContents: [:stream | self displayOn: stream]! !

!SystemDictionary methodsFor: '*mc2-squeak-smalltalk' stamp: 'cwp 12/22/2006 22:35'!
commit
	! !

!MDTimestamp class methodsFor: '*mc2-squeak-smalltalk' stamp: 'cwp 8/12/2008 20:47'!
fromSqueakMethodStamp: aString
	| stream month day year hour minute |
	stream := ReadStream on: aString.
	[stream peek isDigit] whileFalse: [stream next].
	month := (stream upTo: $/) asNumber.
	day := (stream upTo: $/) asNumber.
	year := (stream upTo: Character space) asNumber.
	hour := (stream upTo: $:) asNumber.
	minute := (stream upTo: Character space) asNumber.
	stream atEnd ifFalse: [(stream next: 2) = 'pm' ifTrue: [hour := hour + 12]].
	
	year < 1980 ifTrue:
		[year < 100 
			ifTrue: [year := year + (year < 80 ifTrue: [2000] ifFalse: [1900])]
			ifFalse: [^ nil]].
	
	^ self year: year month: month day: day hour: hour minute: minute second: 0! !

!MDTimestampTest methodsFor: '*mc2-squeak-smalltalk' stamp: 'cwp 5/22/2008 00:10'!
testFromSqueakMethodStamp
	| ts |
	ts := MDTimestamp fromSqueakMethodStamp: 'cwp 4/7/2005 01:30'.
	self assert: ts printString = '7 April 2005 1:30:00 am'! !

MDSliceElement subclass: #MDChangeSetSliceElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Smalltalk-Elements'!

!MDChangeSetSliceElement methodsFor: 'adapting' stamp: 'jf 10/4/2009 20:21'!
adaptedFor: aDomain 
	^ aDomain adaptorForChangeSetSliceElement: self! !

!MDChangeSetSliceElement methodsFor: 'dispatching' stamp: 'cwp 10/16/2009 22:33'!
handleWith: anObject
	^ anObject handleChangeSetSlice: self! !

MDSliceElement subclass: #MDPackageInfoSliceElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Smalltalk-Elements'!

!MDPackageInfoSliceElement methodsFor: 'adapting' stamp: 'jf 10/4/2009 20:31'!
adaptedFor: aDomain 
	^ aDomain adaptorForPackageInfoSliceElement: self! !

!MDPackageInfoSliceElement methodsFor: 'dispatching' stamp: 'cwp 10/16/2009 22:33'!
handleWith: anObject
	^ anObject handlePackageInfoSlice: self! !

!MDDefaultDomainTest methodsFor: '*mc2-squeak-smalltalk-tests' stamp: 'cwp 6/15/2008 20:26'!
testSmalltalk
	self assertDefaultIdentityFor: #smalltalk! !
